/**
 * 产品层全局空间
 */
var DT = DT || {};
/**
 * 命名空间方法
 */
DT.namespace = function() {
    var a = arguments,
        o = null,
        i, j, pkgFragments, rt, np;
    for (i = 0; i < a.length; i = i + 1) {
        pkgFragments = a[i].split(".");
        rt = pkgFragments[0];
        eval('if (typeof ' + rt + ' == "undefined"){' + rt + ' = {};} o = ' + rt + ';');
        np = rt;
        o.__namespace = rt;
        for (j = 1; j < pkgFragments.length; j = j + 1) {
            o[pkgFragments[j]] = o[pkgFragments[j]] || {};
            o = o[pkgFragments[j]];
            o.rt = o.rt + pkgFragments[j];
            np += '.' + pkgFragments[j];
            o.__namespace = np;
        }
    }
    return o;
};



/**
 * 动态注册Module 
 */
DT.registerModule = function() {
    if (arguments.length != 2) {
        return;
    }
    methodName = arguments[0];
    var commonJS = "(function(common) {" + "common." + methodName +
        "= function(){if(arguments.length != 1) { return;} DT.JSBridge.callNative(common.__namespace, \"" +
        methodName + "\", arguments[0]);}});";
    eval(commonJS);
}

/**
 * 交互核心入口
 */
DT.namespace("DT.JSBridge");
(function(JSBridge) {
    /**
     * 返回函数集合
     */
    var DTCallBackList = {};
    /**
     * 点击修改事件集合
     */
    var DTCallChangeList = {};
    /**
     * 方法参数集合
     */
    var DTParameterInfoList = {};
    /**
     * 协议名称
     */
    var scheme = "";
    /**
     * 应用程序名称
     */
    var host = "";

    /**
     * 初始化函数
     */

    var init = function() {
        scheme = "DTGasStation";
        host = "DTApp";
    };

    //获取随机数
    var randomNumber = function() {
        var Range = Math.pow(2, 53);
        var Rand = Math.random();
        return Math.round(Rand * Range);
    };
    var Util = {
        slice: Array.prototype.slice
    };
    var _generateGuid = function() {
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
            var r = Math.random() * 16 | 0;
            var v = c == 'x' ? r : (r & 0x3 | 0x8);
            return v.toString(16);
        })
    };
    var _funProcess = function(identifier, itemName, data) {
        for (var item in data) {
            if (typeof data[item] == "function") {
                var changeIdentifier = identifier + itemName + item;
                DTCallChangeList[changeIdentifier] = data[item];
                data[item] = changeIdentifier;
            } else if (typeof data[item] == "object") {
                itemName = itemName + item;
                _funProcess(identifier, itemName, data[item]);
            } else {
                continue;
            }
        }
    };

    JSBridge.callChange = function(JSONData) {
        if (JSONData == undefined || JSONData.length < 1) {
            return;
        }
        var JSONString = DT.base64.decode(JSONData);
        var obj = JSON.parse(JSONString);
        if (obj.config.scheme == scheme && obj.config.host == host) {
            var result = DTCallChangeList[obj.identifier];
            var jsonObj = {
                header: obj.header,
                data: obj.data
            };
            if (result != null) {
                result(jsonObj);
            }
        }
    };

    JSBridge.callBack = function(JSONData) {
        if (JSONData == undefined || JSONData.length < 1) {
            return;
        }
        console.log("callBack: "+ JSONData);
        try {
            var JSONString = DT.base64.decode(JSONData);
            var obj = JSON.parse(JSONString);
            if (obj.config.scheme == scheme && obj.config.host == host) {
                var result = DTCallBackList[obj.identifier];
                delete DTCallBackList[obj.identifier];
                var jsonObj = {
                    header: obj.header,
                    data: obj.data
                };
                if (result != null) {
                    result(jsonObj);
                }
            }
        } catch (e) {
            alert(e.message);
            alert(e.stack);
        }
    };

    JSBridge.callNative = function() {
        var args = Util.slice.call(arguments);
        if (!args) {
            alert('arguments error');
        }
        try {
            var funName = args[0];
            var jsonData = args[1];
            var jscallBack = args[2];
            //生成唯一标识
            var identifier = _generateGuid();
            if (jsonData != undefined) {
                //保存callBack
                if (jscallBack != undefined) {
                    DTCallBackList[identifier] = jscallBack;
                }
                //data结枸数据处理
                if (jsonData != undefined) {
                    //方法处理
                    for (var item in jsonData) {
                        if (typeof jsonData[item] == "function") {
                            var changeIdentifier = identifier + item;
                            DTCallChangeList[changeIdentifier] = jsonData[item];
                            jsonData[item] = changeIdentifier;
                        } else if (typeof jsonData[item] == "object") {
                            _funProcess(identifier, item, jsonData[item]);
                        } else {
                            continue;
                        }
                    }
                }
            }

            if (DT.Utils.isMobile()) {
                var index = funName.lastIndexOf("Sync");
                console.log("index: "+ index)
                //传参JSON对象
                var jsonObject = {
                    identifier: identifier,
                    config: {
                        scheme: scheme,
                        host: host
                    },
                    functionName: funName
                };
                if (jsonData != undefined) {
                    jsonObject["jsonData"] = jsonData;
                }
                var parameterString = JSON.stringify(jsonObject);

                if (index == -1) {
                    if (DT.Utils.isiOS()) {
                        try {
                            // wkwebview
                            window.webkit.messageHandlers.DTJSBridge.postMessage(parameterString);
                        } catch (e) {

                        }
                    } else if (DT.Utils.isAndroid()) {
                        // 异步方法 android
                        window.DTJSBridge.callNative(parameterString);
                    }
                } else {
                    // 同步方法
                    // var obj = JSON.parse(parameterString);
                    if (DT.Utils.isiOS()) {
                        // 同步方法ios 

                        var resultjson = prompt(parameterString);
                        var resultObj = resultjson ? JSON.parse(resultjson) : {};
                        return resultObj;
                    } else if (DT.Utils.isAndroid()) {
                        // 同步方法android
                        var resultjson = window.DTJSBridge.callNativeSync(parameterString);
                        console.log("resultjson:"+ resultjson);
                        var resultObj = resultjson ? JSON.parse(resultjson) : {};
                        return resultObj;
                    }
                }
            }
            // 调用浏览器
            else {
                alert(DT.Utils.isMobile());
            }
        } catch (e) {
            alert(e.message);
            alert(e.stack);
        }
    };

    JSBridge.register = function(sc, ho) {
        scheme = sc;
        host = ho;
    };


})(DT.JSBridge)




/**
 * 检测浏览器版本
 */

DT.namespace("DT.Utils");
//取得浏览器的userAgent字符串
var userAgent = navigator.userAgent;
var isAndroid = (/(Android);?[\s\/]+([\d.]+)?/.test(userAgent));
var isIOS = !!userAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);

DT.Utils.isAndroid = function() {
    return isAndroid;
}

DT.Utils.isiOS = function() {
    return isIOS;
}

DT.Utils.isMobile = function() {
    return isIOS || isAndroid;
}


/**
 * 获取当前时间，返回格式：20160328204030123
 */
DT.Utils.currentDateTime = function() {
    var currentDT = new Date();
    var y, m, d, hs, ms, ss, fs, theDateStr;
    y = currentDT.getFullYear();
    m = currentDT.getMonth();
    d = currentDT.getDate();
    hs = currentDT.getHours();
    ms = currentDT.getMinutes();
    ss = currentDT.getSeconds();
    fs = currentDT.getMilliseconds();
    theDateStr = y + "" + m + "" + d + "" + hs + "" + ms + "" + ss + "" + fs;
    return theDateStr;
};

/**
 * base64 加解密
 */
DT.namespace("DT.base64");
(function(base64) {
    var _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
    base64.encode = function(input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;
        input = _utf8_encode(input);
        while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;
            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }
            output = output +
                _keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
                _keyStr.charAt(enc3) + _keyStr.charAt(enc4);
        }
        return output;
    };

    base64.decode = function(input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        while (i < input.length) {
            enc1 = _keyStr.indexOf(input.charAt(i++));
            enc2 = _keyStr.indexOf(input.charAt(i++));
            enc3 = _keyStr.indexOf(input.charAt(i++));
            enc4 = _keyStr.indexOf(input.charAt(i++));
            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;
            output = output + String.fromCharCode(chr1);
            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }
        }
        output = _utf8_decode(output);
        return output;
    };

    var _utf8_encode = function(string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            } else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            } else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }
        return utftext;
    };

    var _utf8_decode = function(utftext) {
        var string = "";
        var i = 0;
        var c = 0,
            c1 = 0,
            c2 = 0,
            c3 = 0;
        while (i < utftext.length) {
            c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            } else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            } else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    };
})(DT.base64);


DT.namespace("DT.ENUM");
/**
 * webDeal外部处理，appDeal内部处理
 * 回调参数 codeType    0 条形码  1 二维码    codeContent   扫描所得码数据内容
 * @type {{webDeal: string, appDeal: string}}
 */
DT.ENUM.scanQrCode = {
    webDeal :"1",
    appDeal:"0"
}
/**
 * 拍照选择枚举
 * @type {{sourceTypeCamera: string, sourceTypePhotoAlbum: string, sourceTypeAll: string, ImageExtendPng: string, ImageExtendJpg: string}}
 */
DT.ENUM.chooseImage = {
    sourceTypeCamera: "camera", // 拍照
    sourceTypePhotoAlbum: "photoAlbum ", //相册
    sourceTypeAll: "all", // 两者
    ImageExtendPng: "png",
    ImageExtendJpg: "jpg"

}
/**
 * 1识别，2不识别
 * @type {{discern: string, noDiscern: string}}
 */
DT.ENUM.photoDiscern = {
    discern :"1",
    noDiscern:"2"
}