/**
 * 自定义导航条
 */
function myFunctionNavigationBar() {
    DT.JSBridge.callNative("initNavigationBar", {
        "navigationBarTitle": "主页", //标题
        "backEvent": "hrefEvent()", // 如果是二级页面注册back时需要回退的地址
        "leftNavigationBarItem": {
            "callEvent": function(result) {
                console.log(result)
                alert(JSON.stringify(result));
            },
            "eventType": "startShare",
            "name": "获取网络状态",
            "data": {},
        },
        "rightNavigationBarItem": [{
            "eventType": "photoDiscern",
            "name": "上传行驶证",
            "data": { type: DT.ENUM.photoDiscern.discern},
            "callEvent": function(result) {
                console.log(result)
                alert(JSON.stringify(result));
            },
        },
            {
                "eventType": "photoDiscern",
                "name": "上传资格证",
                "data": { type: DT.ENUM.photoDiscern.noDiscern },
                "callEvent": function(result) {
                    console.log(result)
                    alert(JSON.stringify(result));
                },
            },
            {
                "eventType": "chooseImage",
                "name": "拍照",
                "data": {
                    "sourceType": DT.ENUM.chooseImage.sourceTypeCamera, // photoAlbum 相册选择  camera 拍照选择 all 拍照和选择照片
                    "ImageExtend": DT.ENUM.chooseImage.ImageExtendJpg, // 图片类型 png 、 jpg
                    "allowsEditing": false, // 是否允许裁剪图片
                    "compression": true, //是否压缩
                    "compressionRatioAndroid": 90, //压缩比例 0- 100
                    "compressionRatioIos": 90 //压缩比例 0- 100
                },
                "callEvent": function(result) {
                    console.log(result)
                    alert(JSON.stringify(result));
                },
            },
            {
                "eventType": "scanQrCode",
                "name": "扫描",
                "data": { type: DT.ENUM.scanQrCode.appDeal},
                "callEvent": function(result) {
                    alert(JSON.stringify(result));
                },
            },
            {
                "eventType": "tologin",
                "name": "去登录",
                "data": {},
                "callEvent": function(result) {
                    alert(JSON.stringify(result));
                },
            },


        ]
    }, function(result) {
        alert(JSON.stringify(result));
    })
}
function setNavigationBar(){
    DT.JSBridge.callNative("initNavigationBar", {
        "navigationBarTitle": "主页", //标题
    }, function(result) {
        alert(JSON.stringify(result));
    })
}
function hrefEvent() {
    location.href = "https://www.baidu.com"
}

/**
 * 打开新window
 */
function pushWindow() {
    DT.JSBridge.callNative('pushWindow', {
        url: "https://m.taobao.com/"
    }, function(result) {
        alert(JSON.stringify(result));
    })
}
/**
 * 退出当前Window
 */
function popWindow() {
    DT.JSBridge.callNative('popWindow', {}, function(result) {
        alert(JSON.stringify(result));
    });
}

/**
 * 图片选择器
 */
function chooseImage() {
    DT.JSBridge.callNative('chooseImage', {
        "sourceType": DT.ENUM.chooseImage.sourceTypeCamera, // photoAlbum 相册选择  camera 拍照选择 all 拍照和选择照片
        "ImageExtend": DT.ENUM.chooseImage.ImageExtendJpg, // 图片类型 png 、 jpg
        "allowsEditing": false, // 是否允许裁剪图片
        "compression": true, //是否压缩
        "compressionRatioAndroid": 100, //压缩比例 0- 100
        "compressionRatioIos": 60 //压缩比例 0- 100
    }, function(result) {
        console.log(result)
        if (result.header.code == "0") {
            document.getElementById("chooseImage").innerHTML="<img style='width: 100%; height: 100%' src='data:image/png;base64,"+result.data.imageData+"'>";
            console.log(result)
           // alert(result.data.imageData); //图片base64数据
        } else {
            alert("选择照片失败");
        }
    });
}
function isLoginSync() {
    var obj =  DT.JSBridge.callNative("isLoginSync", {});
    console.log(obj);
    document.getElementById("isLoginSync").innerHTML = obj.isLogin;
    if(obj.isLogin){
        document.getElementById('loginshow').style.display = "block";
    }
}
//isLoginSync();

function tologin() {
    DT.JSBridge.callNative("tologin", {}, function(result) {
        // 回调登录成功 登录失败
        console.log(result);
        if(result.header.code == "0"){
            document.getElementById('loginshow').style.display = "block";
        }
        alert(JSON.stringify(result));
    });
}

/**
 * 图片预览器
 */
function imageViewer() {
    DT.JSBridge.callNative('imageViewer', {
        "imagesUrl": ["https://gw.alipayobjects.com/zos/rmsportal/TVIpxsgyWyvrUKHwOvPY.jpg",
            "https://gw.alipayobjects.com/zos/rmsportal/BSccQoKEYEaKgUAGMkdr.jpg",
        ],
        "init": 0 // 默认显示第几张
    }, function(result) {
        alert(JSON.stringify(result));
    });
}

/**
 * 呼出城市选择列表
 */
function getCities() {
    DT.JSBridge.callNative("getCities", {

    }, function(result) {
        alert(JSON.stringify(result));
    })
}

/**
 *获取当前位置经纬度
 */
function getCurrentLocation() {
    DT.JSBridge.callNative("getCurrentLocation", {}, function(result) {
        if (result.header.code == "0") {
            alert(JSON.stringify(result));
        } else {
            alert("获取位置失败");
        }
    })
}

/**
 * 打开地图
 */
function openLocationMap() {
    DT.JSBridge.callNative("openLocationMap", {}, function(result) {
        if (result.header.code == "0") {
            alert(JSON.stringify(result));
        } else {
            alert("调用地图失败");
        }
    })
}

/**
 * 获取当前网络状态
 */
function getNetworkReachability() {
    DT.JSBridge.callNative("getNetworkReachability", {}, function(result) {
        if (result.header.code == "0") {
            if (result.data != undefined) {
                switch (parseInt(result.data.netWorkStatus)) {
                    case 0:
                        alert("无网络");
                        break;
                    case 1:
                        alert("移动网络");
                        break
                    case 2:
                        alert("WiFi网络");
                        break;

                    default:
                        break;
                }
            }
        }
    });
}


/**
 * 获取用户信息
 */
function getUserInfo() {
    DT.JSBridge.callNative("getUserInfo", {}, function(result) {
        alert("123334")
        console.log(typeof result);
        console.log(result.data.userID);
        alert(JSON.stringify(result));
    });
}

/**
 *开始分享
 */
function startShare() {
    DT.JSBridge.callNative("startShare", {
        "shareUrl": "http://test.api.my-dt.com/gas/html/userAgreement/car_agreement.html?shareUserId=367681255166316544",
        "imgUrl": "http://dtgas.oss-cn-beijing.aliyuncs.com/picture/find/appicon.png",
        "shareTitle": "每月加油就送优惠券",
        "shareTitleDesc": "来来来，DT加油优惠券在手，加油优惠不用愁！",
        "webUrl": "http://test.api.my-dt.comhttps://www.baidu.com",
        "title": "的哥的姐的福利"
    }, function(result) {
        alert(JSON.stringify(result));
    });
}
/**
 * 提示框
 */
function showToast() {
    DT.JSBridge.callNative("showToast", {
        "message": "今天天气不错"
    });
}
/**
 *  3DES加密
 */
function encrypt3DE() {
    var src = document.getElementById("des3Encrypt").value;
    var data = src;
    console.log(data);
    DT.JSBridge.callNative("encryptDefault", {
        "pageSize": "0",
        "paymentSubChannel":"5",
        "limitUseScene": "1"
    }, function(result) {
        console.log(result);
        document.getElementById("encrypt3DE").innerHTML = JSON.stringify(result);
        document.getElementById("des3Decrypt").value = JSON.stringify(result);
    })
}
function getSelectCityInfoSync(){
    DT.JSBridge.callNative("getSelectCityInfoSync", {}, function(result) {
        console.log(result);
        document.getElementById("getSelectCityInfoSync").innerHTML = JSON.stringify(result);
    })
}
function networkRequest() {
    var data = {
        "pageSize": "0",
        "paymentSubChannel":"5",
        "limitUseScene": "1"
    }
    DT.JSBridge.callNative("networkRequest", {
        url: "order/getUserOrderInfo", //lgas/user/getVersion
        type: "post", // post  get
        data: data //data 业务数据
    }, function(result) {
        console.log("请求后台接口：" + result)
        console.log(typeof result)
        document.getElementById("networkRequest").innerHTML = result.data + "===="+ JSON.stringify(result);
        alert(result.data)
    })
}

function encrypt3DEs(){
    var src = document.getElementById("des3Encrypts").value;
    var data = src;
    console.log(data);
    DT.JSBridge.callNative("encryptDefault", {
        "userId": "390860294710235136",
        "orgId":"262957200002125824",
        "activitySn": "activitysn_start_work"
    }, function(result) {
        console.log(result);
        document.getElementById("encrypt3DEs").innerHTML = JSON.stringify(result);
        document.getElementById("des3Decrypt").value = JSON.stringify(result);
    })
}
/**
 *3DES解密
 */
function decrypt3DES() {
    var src = document.getElementById("des3Decrypt").value;
    console.log(src);
    console.log(typeof src);
    console.log(JSON.parse(src));
    console.log("==============");
    var data = JSON.parse(src).data;
    console.log(data);
    console.log(typeof data);
    $.ajax({
        url: "/gas/h5/activityCenter/addStartWorkeGetUserCoupon", //"/gas/order/getUserOrderInfo",
        type: "post",
        data: "AppRequest="+data,//JSON.stringify(data)
        dataType: "json",
        // headers: {
        //     "content-Type": "application/json",
        // },
        async: false,
        beforeSend: function () {
            return true
        },
        success: function (d) {
            if (d.code === 100) {
                alert(message);
            } else {
               console.log(d);
               var data = d.data;
                DT.JSBridge.callNative("decrypt3DES", {
                    data
                }, function(result) {
                    console.log(result);
                    document.getElementById("decrypt3DES").innerHTML = JSON.stringify(result);
                });
            }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            if (XMLHttpRequest.status === 0) {
                alert("网络异常，请检查您的网络！")
            } else {
                if (XMLHttpRequest.status === 404) {
                    alert("服务器异常，请稍后重试..！")
                } else {
                    if (XMLHttpRequest.status === 500) {
                        alert("服务器被挤爆了")
                    } else {
                        alert("网络超时")
                    }
                }
            }
        }
    })
}

/**
 * 扫描二维码
 */
function scanQrCode() {
    DT.JSBridge.callNative("scanQrCode", {
        type: DT.ENUM.scanQrCode.appDeal

}, function(result) {
        alert(JSON.stringify(result));
    });
}

/**
 * 行驶证识别代码
 */
function photoDiscern(index){
    if(index == 1){
        console.log("index: "+ index);
        DT.JSBridge.callNative("photoDiscern", {
            type: DT.ENUM.photoDiscern.discern
        }, function(result) {
            console.log(JSON.stringify(result));
            alert(JSON.stringify(result));
            document.getElementById("loadUrls").innerHTML="<img style='width: 100%; height: 100%' src='data:image/png;base64,"+result.data.img+"'>";

        });

    }
    if(index ==2){
        console.log("index: "+ index);
        DT.JSBridge.callNative("photoDiscern", {
            type: DT.ENUM.photoDiscern.noDiscern
        }, function(result) {
            console.log(JSON.stringify(result));
            alert(JSON.stringify(result));
            document.getElementById('secondsheetsUrl').innerHTML ="<img style='width: 100%; height: 100%' src='data:image/png;base64,"+result.data.img+"'>";
        });

    }

}

/**
 * 测试ajax跨域问题
 */
function testAJAX() {
    var AppRequest = {
        "context": {
            "userId": "1234567890"
        },
        "data": {
            "userId": "1234567890",
            "name": "123456789",
            "orgId": "1234567",
            "mobile": "1234567890",
            "recommendCode": "123456",
            "activitySn": "mobileActivity"
        }
    };
    $.ajax({
        url: 'http://dev.api.my-dt.com:8085/gas/activity/addMoblieActivity',
        type: "post",
        data: "AppRequest=" + JSON.stringify(AppRequest),
        dataType: "json",
        async: false,
        timeout: 5000,
        beforeSend: function() {
            return true;
        },
        success: function(obj) {
            console.log(obj);
        },
        error: function(XMLHttpRequest, textStatus, errorThrown) {

        },
        complete: function() {
            console.log("结束");
        }
    });
}
function saveData() {
    let key = document.getElementById("key").value;
    let value = document.getElementById("value").value;
    if(key.length == 0){
        alert("存储数据 key不能为空")
    }
    DT.JSBridge.callNative("saveData", {
        dataKey: key, // 键值
        dataValue: value // 存储数据
    }, function(result) {
        console.log(result);
        alert(JSON.stringify(result));
        document.getElementById("data").innerHTML =JSON.stringify(result);
    })
}
function readData() {
    let key = document.getElementById("key").value;
    if(key.length == 0){
        alert("读取数据 key不能为空")
    }
    DT.JSBridge.callNative("readData", {
        dataKey: key
    }, function(result) {
        console.log(result);
        alert(JSON.stringify(result));
        document.getElementById("data").innerHTML =JSON.stringify(result);
    })
}
function deleteData() {
    let key = document.getElementById("key").value;
    if(key.length == 0){
        alert("删除数据 key不能为空")
    }
    DT.JSBridge.callNative("deleteData", {
        dataKey: key
    }, function(result) {
        console.log(result);
        alert(JSON.stringify(result));
        document.getElementById("data").innerHTML =JSON.stringify(result);
    })
}